
//
//  UIButton+TouchArea.swift
//  ButtonPadding
//
//  Created by yamyee on 2018/6/15.
//  Copyright © 2018年 yamyee. All rights reserved.
//

import UIKit
import Foundation

struct runtimeKey {
    
   static var enlargeEdgeKey = "enlargeEdgeKey"
    
}
extension UIButton{

    var enlarge : UIEdgeInsets {
        
        set{
            
            let value = NSValue.init(uiEdgeInsets: newValue)
            objc_setAssociatedObject(self, &runtimeKey.enlargeEdgeKey, value, objc_AssociationPolicy.OBJC_ASSOCIATION_COPY_NONATOMIC)
        }
        
        get{
            
            if let edge = objc_getAssociatedObject(self, &runtimeKey.enlargeEdgeKey) {
                
                return edge as! UIEdgeInsets
            }
            return UIEdgeInsets.zero
        }
    }
    
    func largeBounds() -> CGRect {
        
        return CGRect(x: self.bounds.origin.x - enlarge.left, y: self.bounds.origin.y - enlarge.top, width: self.bounds.width + enlarge.left + enlarge.right, height: self.bounds.height + enlarge.top + enlarge.bottom)
    }
    
    open override func point(inside point: CGPoint, with event: UIEvent?) -> Bool {
        
        if !self.isEnabled || self.isHidden{
            return super.point(inside: point, with: event)
        }
        return largeBounds().contains(point);
    }
}
